package ${PACKAGE_NAME};

import com.nhn.gameanvil.annotation.RoomType;
import com.nhn.gameanvil.annotation.ServiceName;
import com.nhn.gameanvil.node.game.data.RoomMatchResultCode;
import com.nhn.gameanvil.node.match.BaseRoomMatchMaker;

import java.util.List;
import java.util.stream.Collectors;

@ServiceName("${Service_Name}")
@RoomType("${Room_Type}")
public class ${NAME} extends BaseRoomMatchMaker<${Room_Match_Form_Class}, ${Room_Match_Info_Class}> {

    @Override
    public RoomMatchResultCode onPreMatch(${Room_Match_Form_Class} roomMatchForm, Object... args) {
        return RoomMatchResultCode.SUCCESS;
    }

    @Override
    public boolean canMatch(${Room_Match_Form_Class} roomMatchForm, ${Room_Match_Info_Class} roomMatchInfo, Object... args) {
        return true;
    }

    @Override
    public void onPostMatch(${Room_Match_Form_Class} baseRoomMatchForm, ${Room_Match_Info_Class} baseRoomMatchInfo, Object... args) {

    }

    @Override
    public int compare(${Room_Match_Info_Class} o1, ${Room_Match_Info_Class} o2) {
        return 0;
    }

    @Override
    public void onIncreaseUserCount(int roomId, String matchingUserCategory, int currentUserCount) {
        sort();
    }

    @Override
    public void onDecreaseUserCount(int roomId, String matchingUserCategory, int currentUserCount) {
        sort();
    }

    @Override
    public List<${Room_Match_Info_Class}> getRooms(List<${Room_Match_Info_Class}> rooms) {
        List<${Room_Match_Info_Class}> gameRoomMatchInfoList = rooms.stream().limit(10).collect(Collectors.toList());
        return gameRoomMatchInfoList;
    }
}